using System;
using System.Collections ;
using System.Collections.Specialized ;

namespace shobonjtag
{
	/// <summary>
	/// foCXp[^`NX interface JtagDevice pč܂
	///
	/// EP1C6Q240 ̃foCXp[^`
	/// </summary>
	public class EP1C6Q240 : JtagDevice
	{
		/// <summary>
		/// tH[
		/// </summary>
		ViewForm vf ;

		/// <summary>
		/// CXgNVe[u
		/// </summary>
		static StringDictionary inst ;

		/// <summary>
		/// CXgNVe[u(Hashtable)ĕԂ
		/// </summary>
		/// <returns>e[û</returns>
		static StringDictionary CreateInstruction() {
			StringDictionary sd = new StringDictionary() ;
			//      "BYPASS ( 1111111111)," &
			sd.Add( "BYPASS","1111111111") ;
			//		"EXTEST ( 0000000000)," &
			sd.Add( "EXTEST","0000000000") ;
			//		"SAMPLE ( 0000000101)," &
			sd.Add( "SAMPLE","0000000101") ;
			//		"IDCODE ( 0000000110)," &
			sd.Add( "IDCODE","0000000110") ;
			//		"USERCODE  (0000000111), "&
			sd.Add( "USERCODE","0000000111") ;
			//		"CLAMP  (0000001010), "&
			sd.Add( "CLAMP","0000001010") ;
			//		"HIGHZ  (0000001011), "&
			sd.Add( "HIGHZ","0000001011") ;
			//		"CONFIG_IO  (0000001101)";
			sd.Add( "CONFIG_IO","0000001101") ;

			return sd ;
		}

		public EP1C6Q240()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			if (inst == null) {
				inst = CreateInstruction() ;
			}
		}

		#region JtagDevice o

		public String LSINAME {
			get {
				return "Cyclone-EP1C6Q240" ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				return 10.00e6 ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				return 10 ;
			}
		}

		public StringDictionary INSTRUCTION_OPCODE {
			get {
				return inst ; // RXgN^łƍĕԂ
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				return "0101010101" ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {
				return 582;
			}
		}

		public String GetInstruction(String instType) {
			return inst[instType] ;
		}

		public void showViewForm() {
			if (vf == null) {
				vf = new ViewForm(LSINAME) ; 
			}
			vf.Show() ;
		}

		public void disposeViewForm() {
			if (vf != null) {
				vf.Close() ;
				vf = null ;
			}
		}
		
		#endregion

		#region SignalListener o

		public void SendSignal(string signalvector) {
			if (vf != null) {
				SignalListener sl = vf as SignalListener;
				sl.SendSignal(signalvector) ;
			}
		}

		#endregion
	}
}
